<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <title>PTO - Who's out converter</title>
    <script src="https://unpkg.com/vue@next"></script>
    <link rel="stylesheet" href="https://unpkg.com/purecss@2.0.6/build/pure-min.css" integrity="sha384-Uu6IeWbM+gzNVXJcM9XV3SohHtmWE+3VGi496jvgX1jyvDTXfdK+rfZc8C1Aehk5" crossorigin="anonymous">
    <link rel="stylesheet" href="https://unpkg.com/purecss@2.0.6/build/grids-responsive-min.css">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <style>
      #pto-converter {
        padding: 1%;
      }

      .pto-textarea {
        height: 20em;
      }
    </style>
  </head>
  <body>
    <div id="pto-converter">
      <form class="pure-form">
        <fieldset>
          <div class="pure-g">
            <div class="pure-u-1 pure-u-md-1-2">
              <input class="pure-u-23-24" v-model="yourName" placeholder="Your name on Slack"/>
            </div>
            <div class="pure-u-1 pure-u-md-1-2">
              <input class="pure-u-1" v-model="yourHandle" placeholder="Your handle on Slack (@user)"/>
            </div>
          </div>
        </fieldset>
        <fieldset class="pure-group">
          <textarea class="pure-input-1 pto-textarea" v-model="inputValue" placeholder="Paste data from PTO by Roots"></textarea>
        </fieldset>
        <button v-on:click.stop.prevent="convertPtoData" class="pure-button pure-input-1 pure-button-primary">Convert</button>
        <fieldset class="pure-group">
          <textarea class="pure-input-1 pto-textarea" v-model="convertedValue"></textarea>
        </fieldset>

        <div class="pure-g">
          <div class="pure-u-1"><h1>Instructions</h1></div>
          <div class="pure-u-1">
            <p>1. Fill <strong>Your name on Slack</strong> and <strong>Your handle on Slack</strong> fields.</p>
            <p>2. Open converation with PTO by Roots bot in Slack.</p>
            <p>3. Write <code>/pto-roots whosout @your-group</code> and change window to <strong>Next 30 Days</strong> and copy result (after <strong>Out Soon</strong>).</p>
            <p>4. Paste results to provided field. Supported format from PTO by Roots Slack bot:</p>
          </div>
          <div class="pure-u-1">
            <pre>
              :palm_tree: Terrance Sanders (@tsanders)
              2021-12-17
              :palm_tree: Tamara Rodriguez (@Tamara Rodriguez)
              2021-12-18 - 2021-12-27
              ...
            </pre>
          </div>
        </div>
      </div>
    </form>
    </div>
    <script>
      const toDateOnly = (date) => {
        return date.toISOString().slice(0, 10);
      };

      const EventHandling = {
        data() {
          return {
            yourName: '',
            yourHandle: '',
            inputValue: '',
            convertedValue: ''
          }
        },
        methods: {
          convertPtoData() {
            const nextDays = {};

            if (!this.yourName || !this.yourHandle) {
              alert("Please provide your name and handle on Slack!");
              return;
            }

            const inputArray = this.inputValue
              .replaceAll('You', `${this.yourName} (${this.yourHandle})`)
              .split("\n");

            let startDate, endDate;
            let result = [];

            if (inputArray.length < 2) {
              return;
            }

            for (let index = 0; index < inputArray.length; index += 2) {
              let [startDate, endDate] = inputArray[index + 1].split(" - ", 2).map((date) => new Date(date));
              let match = /(?<emoji>\:.+\:)\s+(?<name>.+)\s+\((?<handle>.+)\)/.exec(inputArray[index]);
              let event = `${match.groups.emoji} ${match.groups.name} (\`${match.groups.handle}\`)`;

              nextDays[toDateOnly(startDate)] = nextDays[toDateOnly(startDate)] || [];

              if (endDate) {
                for (const date = startDate; date <= endDate; date.setDate(date.getDate() + 1)) {
                  nextDays[toDateOnly(date)] = nextDays[toDateOnly(date)] || [];
                  nextDays[toDateOnly(date)].push(event);
                }
              } else {
                nextDays[toDateOnly(startDate)].push(event);
              }
            }

            for (const date in nextDays) {
              if (nextDays[date].length > 0) {
                result.push(`*${date}*:`);
                for (const event of nextDays[date]) {
                  result.push(`* ${event}`);
                }
                result.push('');
              }
            }

            this.convertedValue = result.join("\n");
          }
        }
      }

      Vue.createApp(EventHandling).mount('#pto-converter')
    </script>
  </body>
</html>

